/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSATSTypesetter;

//import dstep.appkit.NSParagraphStyle;
import dstep.appkit.NSTypesetter;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

const TNSPantherCompatibility = `

	NSRect lineFragmentRectForProposedRect (NSRect proposedRect, NSRectPointer remainingRect)
	{
		return invokeObjcSelf!(NSRect, "lineFragmentRectForProposedRect:remainingRect:", NSRect, NSRectPointer)(proposedRect, remainingRect);
	}

	//mixin ObjcBindMethod!(lineFragmentRectForProposedRect, "lineFragmentRectForProposedRect:remainingRect:");

`;

class NSATSTypesetter : NSTypesetter
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static NSATSTypesetter sharedTypesetter ()
	{
		return invokeObjcSelfClass!(NSATSTypesetter, "sharedTypesetter");
	}
	
	// NSPantherCompatibility
	NSRect lineFragmentRectForProposedRect (NSRect proposedRect, NSRectPointer remainingRect)
	{
		return invokeObjcSelf!(NSRect, "lineFragmentRectForProposedRect:remainingRect:", NSRect, NSRectPointer)(proposedRect, remainingRect);
	}
}