/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSGlyphGenerator;

import dstep.appkit.NSFont;
import dstep.foundation.NSAttributedString;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

enum
{
	NSShowControlGlyphs = (1 << 0),
	NSShowInvisibleGlyphs = (1 << 1),
	NSWantsBidiLevels = (1 << 2)
}

class NSGlyphGenerator : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	void generateGlyphsForGlyphStorage (INSGlyphStorage glyphStorage, NSUInteger nChars, NSUInteger* glyphIndex, NSUInteger* charIndex)
	{
		return invokeObjcSelf!(void, "generateGlyphsForGlyphStorage:desiredNumberOfCharacters:glyphIndex:characterIndex:", INSGlyphStorage, NSUInteger, NSUInteger*, NSUInteger*)(glyphStorage, nChars, glyphIndex, charIndex);
	}

	static Object sharedGlyphGenerator ()
	{
		return invokeObjcSelfClass!(Object, "sharedGlyphGenerator");
	}
}

interface INSGlyphStorage
{
	void insertGlyphs (NSGlyph* glyphs, NSUInteger length, NSUInteger glyphIndex, NSUInteger charIndex);
	void setIntAttribute (NSInteger attributeTag, NSInteger val, NSUInteger glyphIndex);
	NSAttributedString attributedString ();
	NSUInteger layoutOptions ();
}

