/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGFunction;

import dstep.corefoundation.CFBase;
import dstep.applicationservices.coregraphics.CGBase;

struct CGFunction;

alias CGFunction* CGFunctionRef;

extern (C)
{
	alias void function (void*, CGFloat*, CGFloat*) CGFunctionEvaluateCallback;
	alias void function (void*) CGFunctionReleaseInfoCallback;
}

struct CGFunctionCallbacks
{
	uint version_;
	CGFunctionEvaluateCallback evaluate;
	CGFunctionReleaseInfoCallback releaseInfo;
}

extern (C)
{
	uint CGFunctionGetTypeID ();
	CGFunctionRef CGFunctionCreate (void* info, uint domainDimension, CGFloat* domain, uint rangeDimension, CGFloat* range, CGFunctionCallbacks* callbacks);
	CGFunctionRef CGFunctionRetain (CGFunctionRef function_);
	void CGFunctionRelease (CGFunctionRef function_);
}