/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFArray;

import dstep.applicationservices.coregraphics.CGPDFDictionary;
import dstep.applicationservices.coregraphics.CGPDFObject;
import dstep.applicationservices.coregraphics.CGPDFStream;
import dstep.applicationservices.coregraphics.CGPDFString;

struct CGPDFArray;

alias CGPDFArray* CGPDFArrayRef;

extern (C)
{
	uint CGPDFArrayGetCount (CGPDFArrayRef array);
	bool CGPDFArrayGetObject (CGPDFArrayRef array, uint index, CGPDFObjectRef* value);
	bool CGPDFArrayGetNull (CGPDFArrayRef array, uint index);
	bool CGPDFArrayGetBoolean (CGPDFArrayRef array, uint index, char* value);
	bool CGPDFArrayGetInteger (CGPDFArrayRef array, uint index, CGPDFInteger* value);
	bool CGPDFArrayGetNumber (CGPDFArrayRef array, uint index, CGPDFReal* value);
	bool CGPDFArrayGetName (CGPDFArrayRef array, uint index, char** value);
	bool CGPDFArrayGetString (CGPDFArrayRef array, uint index, CGPDFStringRef* value);
	bool CGPDFArrayGetArray (CGPDFArrayRef array, uint index, CGPDFArrayRef* value);
	bool CGPDFArrayGetDictionary (CGPDFArrayRef array, uint index, CGPDFDictionaryRef* value);
	bool CGPDFArrayGetStream (CGPDFArrayRef array, uint index, CGPDFStreamRef* value);
}