/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFDictionary;

import dstep.applicationservices.coregraphics.CGPDFArray;
import dstep.applicationservices.coregraphics.CGPDFObject;
import dstep.applicationservices.coregraphics.CGPDFStream;
import dstep.applicationservices.coregraphics.CGPDFString;

struct CGPDFDictionary;

alias CGPDFDictionary* CGPDFDictionaryRef;

extern (C)
{
	alias void function (char*, CGPDFObjectRef, void*) CGPDFDictionaryApplierFunction;
}

extern (C)
{
	uint CGPDFDictionaryGetCount (CGPDFDictionaryRef dict);
	bool CGPDFDictionaryGetObject (CGPDFDictionaryRef dict, char* key, CGPDFObjectRef* value);
	bool CGPDFDictionaryGetBoolean (CGPDFDictionaryRef dict, char* key, char* value);
	bool CGPDFDictionaryGetInteger (CGPDFDictionaryRef dict, char* key, CGPDFInteger* value);
	bool CGPDFDictionaryGetNumber (CGPDFDictionaryRef dict, char* key, CGPDFReal* value);
	bool CGPDFDictionaryGetName (CGPDFDictionaryRef dict, char* key, char** value);
	bool CGPDFDictionaryGetString (CGPDFDictionaryRef dict, char* key, CGPDFStringRef* value);
	bool CGPDFDictionaryGetArray (CGPDFDictionaryRef dict, char* key, CGPDFArrayRef* value);
	bool CGPDFDictionaryGetDictionary (CGPDFDictionaryRef dict, char* key, CGPDFDictionaryRef* value);
	bool CGPDFDictionaryGetStream (CGPDFDictionaryRef dict, char* key, CGPDFStreamRef* value);
	void CGPDFDictionaryApplyFunction (CGPDFDictionaryRef dict, CGPDFDictionaryApplierFunction function_, void* info);
}