/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFScanner;

import dstep.applicationservices.coregraphics.CGPDFArray;
import dstep.applicationservices.coregraphics.CGPDFContentStream;
import dstep.applicationservices.coregraphics.CGPDFDictionary;
import dstep.applicationservices.coregraphics.CGPDFObject;
import dstep.applicationservices.coregraphics.CGPDFOperatorTable;
import dstep.applicationservices.coregraphics.CGPDFStream;
import dstep.applicationservices.coregraphics.CGPDFString;

struct CGPDFScanner;

alias CGPDFScanner* CGPDFScannerRef;

extern (C)
{
	CGPDFScannerRef CGPDFScannerCreate (CGPDFContentStreamRef cs, CGPDFOperatorTableRef table, void* info);
	CGPDFScannerRef CGPDFScannerRetain (CGPDFScannerRef scanner);
	void CGPDFScannerRelease (CGPDFScannerRef scanner);
	bool CGPDFScannerScan (CGPDFScannerRef scanner);
	CGPDFContentStreamRef CGPDFScannerGetContentStream (CGPDFScannerRef scanner);
	bool CGPDFScannerPopObject (CGPDFScannerRef scanner, CGPDFObjectRef* value);
	bool CGPDFScannerPopBoolean (CGPDFScannerRef scanner, char* value);
	bool CGPDFScannerPopInteger (CGPDFScannerRef scanner, CGPDFInteger* value);
	bool CGPDFScannerPopNumber (CGPDFScannerRef scanner, CGPDFReal* value);
	bool CGPDFScannerPopName (CGPDFScannerRef scanner, char** value);
	bool CGPDFScannerPopString (CGPDFScannerRef scanner, CGPDFStringRef* value);
	bool CGPDFScannerPopArray (CGPDFScannerRef scanner, CGPDFArrayRef* value);
	bool CGPDFScannerPopDictionary (CGPDFScannerRef scanner, CGPDFDictionaryRef* value);
	bool CGPDFScannerPopStream (CGPDFScannerRef scanner, CGPDFStreamRef* value);
}