/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSAttributeDescription;

import dstep.coredata.NSEntityDescription;
import dstep.coredata.NSPropertyDescription;
import dstep.foundation.NSData;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

alias NSUInteger NSAttributeType;

enum
{
	NSUndefinedAttributeType = 0,
	NSInteger16AttributeType = 100,
	NSInteger32AttributeType = 200,
	NSInteger64AttributeType = 300,
	NSDecimalAttributeType = 400,
	NSDoubleAttributeType = 500,
	NSFloatAttributeType = 600,
	NSStringAttributeType = 700,
	NSBooleanAttributeType = 800,
	NSDateAttributeType = 900,
	NSBinaryDataAttributeType = 1000,
	NSTransformableAttributeType = 1800
}

class NSAttributeDescription : NSPropertyDescription
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	uint attributeType ()
	{
		return invokeObjcSelf!(uint, "attributeType");
	}

	void setAttributeType (uint type)
	{
		return invokeObjcSelf!(void, "setAttributeType:", uint)(type);
	}

	NSString attributeValueClassName ()
	{
		return invokeObjcSelf!(NSString, "attributeValueClassName");
	}

	Object defaultValue ()
	{
		return invokeObjcSelf!(Object, "defaultValue");
	}

	void setDefaultValue (Object value)
	{
		return invokeObjcSelf!(void, "setDefaultValue:", Object)(value);
	}

	void setAttributeValueClassName (NSString className)
	{
		return invokeObjcSelf!(void, "setAttributeValueClassName:", NSString)(className);
	}

	NSData versionHash ()
	{
		return invokeObjcSelf!(NSData, "versionHash");
	}

	NSString valueTransformerName ()
	{
		return invokeObjcSelf!(NSString, "valueTransformerName");
	}

	void setValueTransformerName (NSString string)
	{
		return invokeObjcSelf!(void, "setValueTransformerName:", NSString)(string);
	}
}

