/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFPropertyList;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFData;
import dstep.corefoundation.CFStream;
import dstep.corefoundation.CFString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

alias uint CFPropertyListMutabilityOptions;
alias int CFPropertyListFormat;

enum
{
	kCFPropertyListImmutable = 0,
	kCFPropertyListMutableContainers,
	kCFPropertyListMutableContainersAndLeaves
}

enum
{
	kCFPropertyListOpenStepFormat = 1,
	kCFPropertyListXMLFormat_v1_0 = 100,
	kCFPropertyListBinaryFormat_v1_0 = 200
}

extern (C)
{
	void* CFPropertyListCreateFromXMLData (CFAllocatorRef allocator, CFDataRef xmlData, uint mutabilityOption, CFStringRef* errorString);
	CFDataRef CFPropertyListCreateXMLData (CFAllocatorRef allocator, void* propertyList);
	void* CFPropertyListCreateDeepCopy (CFAllocatorRef allocator, void* propertyList, uint mutabilityOption);
	ubyte CFPropertyListIsValid (void* plist, int format);
	int CFPropertyListWriteToStream (void* propertyList, CFWriteStreamRef stream, int format, CFStringRef* errorString);
	void* CFPropertyListCreateFromStream (CFAllocatorRef allocator, CFReadStreamRef stream, int streamLength, uint mutabilityOption, int* format, CFStringRef* errorString);
}