/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.cfnetwork.CFHTTPMessage;

//import dstep.Availability;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFData;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFString;
import dstep.corefoundation.CFURL;
import dstep.coreservices.cfnetwork.CFNetworkDefs;

struct __CFHTTPMessage;

alias __CFHTTPMessage* CFHTTPMessageRef;

extern (C)
{
	extern
	{
		const CFStringRef kCFHTTPVersion1_0;
		const CFStringRef kCFHTTPVersion1_1;
		const CFStringRef kCFHTTPAuthenticationSchemeBasic;
		const CFStringRef kCFHTTPAuthenticationSchemeDigest;
		const CFStringRef kCFHTTPAuthenticationSchemeNTLM;
		const CFStringRef kCFHTTPAuthenticationSchemeNegotiate;
	}
}

extern (C)
{
	uint CFHTTPMessageGetTypeID ();
	CFHTTPMessageRef CFHTTPMessageCreateRequest (CFAllocatorRef alloc, CFStringRef requestMethod, CFURLRef url, CFStringRef httpVersion);
	CFHTTPMessageRef CFHTTPMessageCreateResponse (CFAllocatorRef alloc, int statusCode, CFStringRef statusDescription, CFStringRef httpVersion);
	CFHTTPMessageRef CFHTTPMessageCreateEmpty (CFAllocatorRef alloc, ubyte isRequest);
	CFHTTPMessageRef CFHTTPMessageCreateCopy (CFAllocatorRef alloc, CFHTTPMessageRef message);
	ubyte CFHTTPMessageIsRequest (CFHTTPMessageRef message);
	CFStringRef CFHTTPMessageCopyVersion (CFHTTPMessageRef message);
	CFDataRef CFHTTPMessageCopyBody (CFHTTPMessageRef message);
	void CFHTTPMessageSetBody (CFHTTPMessageRef message, CFDataRef bodyData);
	CFStringRef CFHTTPMessageCopyHeaderFieldValue (CFHTTPMessageRef message, CFStringRef headerField);
	CFDictionaryRef CFHTTPMessageCopyAllHeaderFields (CFHTTPMessageRef message);
	void CFHTTPMessageSetHeaderFieldValue (CFHTTPMessageRef message, CFStringRef headerField, CFStringRef value);
	ubyte CFHTTPMessageAppendBytes (CFHTTPMessageRef message, char* newBytes, int numBytes);
	ubyte CFHTTPMessageIsHeaderComplete (CFHTTPMessageRef message);
	CFDataRef CFHTTPMessageCopySerializedMessage (CFHTTPMessageRef request);
	CFURLRef CFHTTPMessageCopyRequestURL (CFHTTPMessageRef request);
	CFStringRef CFHTTPMessageCopyRequestMethod (CFHTTPMessageRef request);
	ubyte CFHTTPMessageAddAuthentication (CFHTTPMessageRef request, CFHTTPMessageRef authenticationFailureResponse, CFStringRef username, CFStringRef password, CFStringRef authenticationScheme, ubyte forProxy);
	int CFHTTPMessageGetResponseStatusCode (CFHTTPMessageRef response);
	CFStringRef CFHTTPMessageCopyResponseStatusLine (CFHTTPMessageRef response);
}