/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.diskarbitration.DASession;

import dstep.corefoundation.CoreFoundation;
import dstep.corefoundation.CFRunLoop;

struct __DASession;
struct __DAApprovalSession;

alias __DASession* DASessionRef;
alias __DAApprovalSession* DAApprovalSessionRef;

extern (C)
{
	uint DASessionGetTypeID ();
	DASessionRef DASessionCreate (CFAllocatorRef allocator);
	void DASessionScheduleWithRunLoop (DASessionRef session, CFRunLoopRef runLoop, CFStringRef runLoopMode);
	void DASessionUnscheduleFromRunLoop (DASessionRef session, CFRunLoopRef runLoop, CFStringRef runLoopMode);
	uint DAApprovalSessionGetTypeID ();
	DAApprovalSessionRef DAApprovalSessionCreate (CFAllocatorRef allocator);
	void DAApprovalSessionScheduleWithRunLoop (DAApprovalSessionRef session, CFRunLoopRef runLoop, CFStringRef runLoopMode);
	void DAApprovalSessionUnscheduleFromRunLoop (DAApprovalSessionRef session, CFRunLoopRef runLoop, CFStringRef runLoopMode);
}