/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSDistributedLock;

import dstep.foundation.NSDate;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSDistributedLock : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSDistributedLock lockWithPath (NSString path)
	{
		return invokeObjcSuperClass!(NSDistributedLock, "lockWithPath:", NSString)(path);
	}

	Object initWithPath (NSString path)
	{
		return invokeObjcSelf!(Object, "initWithPath:", NSString)(path);
	}

	this (NSString path)
	{
		typeof(this).alloc.initWithPath(path);
	}

	bool tryLock ()
	{
		return invokeObjcSelf!(bool, "tryLock");
	}

	void unlock ()
	{
		return invokeObjcSelf!(void, "unlock");
	}

	void breakLock ()
	{
		return invokeObjcSelf!(void, "breakLock");
	}

	NSDate lockDate ()
	{
		return invokeObjcSelf!(NSDate, "lockDate");
	}
}

