/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSObjectScripting;

import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

const TNSScripting = `

	Object scriptingValueForSpecifier (NSScriptObjectSpecifier objectSpecifier)
	{
		return invokeObjcSelf!(Object, "scriptingValueForSpecifier:", NSScriptObjectSpecifier)(objectSpecifier);
	}
	
	NSDictionary scriptingProperties ()
	{
		return invokeObjcSelf!(NSDictionary, "scriptingProperties");
	}
	
	void setScriptingProperties (NSDictionary properties)
	{
		return invokeObjcSelf!(void, "setScriptingProperties:", NSDictionary)(properties);
	}
	
	Object copyScriptingValue (Object value, NSString key, NSDictionary properties)
	{
		return invokeObjcSelf!(Object, "copyScriptingValue:forKey:withProperties:", Object, NSString, NSDictionary)(value, key, properties);
	}
	
	Object newScriptingObjectOfClass (Class objectClass, NSString key, Object contentsValue, NSDictionary properties)
	{
		return invokeObjcSelf!(Object, "newScriptingObjectOfClass:forValueForKey:withContentsValue:properties:", Class, NSString, Object, NSDictionary)(objectClass, key, contentsValue, properties);
	}
	
	//mixin ObjcBindMethod!(scriptingValueForSpecifier, "scriptingValueForSpecifier:");
	//mixin ObjcBindMethod!(scriptingProperties, "scriptingProperties");
	//mixin ObjcBindMethod!(setScriptingProperties, "setScriptingProperties:");
	//mixin ObjcBindMethod!(copyScriptingValue, "copyScriptingValue:forKey:withProperties:");
	//mixin ObjcBindMethod!(newScriptingObjectOfClass, "newScriptingObjectOfClass:forValueForKey:withContentsValue:properties:");
`;