/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSSortDescriptor;

import dstep.foundation.NSArray;
import dstep.foundation.NSCoder;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.foundation.NSZone;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSSortDescriptor : NSObject, INSCoding, INSCopying
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	Object initWithKey (NSString key, bool ascending)
	{
		return invokeObjcSelf!(Object, "initWithKey:ascending:", NSString, bool)(key, ascending);
	}

	this (NSString key, bool ascending)
	{
		typeof(this).alloc.initWithKey(key, ascending);
	}

	Object initWithKey (NSString key, bool ascending, SEL selector)
	{
		return invokeObjcSelf!(Object, "initWithKey:ascending:selector:", NSString, bool, SEL)(key, ascending, selector);
	}

	this (NSString key, bool ascending, SEL selector)
	{
		typeof(this).alloc.initWithKey(key, ascending, selector);
	}

	NSString key ()
	{
		return invokeObjcSelf!(NSString, "key");
	}

	bool ascending ()
	{
		return invokeObjcSelf!(bool, "ascending");
	}

	SEL selector ()
	{
		return invokeObjcSelf!(SEL, "selector");
	}

	int compareObject (Object object1, Object object2)
	{
		return invokeObjcSelf!(int, "compareObject:toObject:", Object, Object)(object1, object2);
	}

	Object reversedSortDescriptor ()
	{
		return invokeObjcSelf!(Object, "reversedSortDescriptor");
	}

	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}

	Object initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(Object, "initWithCoder:", NSCoder)(aDecoder);
	}

	this (NSCoder aDecoder)
	{
		typeof(this).alloc.initWithCoder(aDecoder);
	}

	Object copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(Object, "copyWithZone:", NSZone*)(zone);
	}
}

const TNSSortDescriptorSorting = `

	NSArray sortedArrayUsingDescriptors (NSArray sortDescriptors)
	{
		return invokeObjcSelf!(NSArray, "sortedArrayUsingDescriptors:", NSArray)(sortDescriptors);
	}
`;

