/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.opengl.OpenGL;

public:

//import dstep.AvailabilityMacros;
import dstep.opengl.CGLCurrent;
import dstep.opengl.CGLTypes;
import dstep.opengl.gl;

extern (C)
{
	int CGLChoosePixelFormat (CGLPixelFormatAttribute* attribs, CGLPixelFormatObj* pix, GLint* npix);
	int CGLDestroyPixelFormat (CGLPixelFormatObj pix);
	int CGLDescribePixelFormat (CGLPixelFormatObj pix, int pix_num, int attrib, GLint* value);
	void CGLReleasePixelFormat (CGLPixelFormatObj pix);
	CGLPixelFormatObj CGLRetainPixelFormat (CGLPixelFormatObj pix);
	uint CGLGetPixelFormatRetainCount (CGLPixelFormatObj pix);
	int CGLQueryRendererInfo (uint display_mask, CGLRendererInfoObj* rend, GLint* nrend);
	int CGLDestroyRendererInfo (CGLRendererInfoObj rend);
	int CGLDescribeRenderer (CGLRendererInfoObj rend, int rend_num, int prop, GLint* value);
	int CGLCreateContext (CGLPixelFormatObj pix, CGLContextObj share, CGLContextObj* ctx);
	int CGLDestroyContext (CGLContextObj ctx);
	int CGLCopyContext (CGLContextObj src, CGLContextObj dst, uint mask);
	CGLContextObj CGLRetainContext (CGLContextObj ctx);
	void CGLReleaseContext (CGLContextObj ctx);
	uint CGLGetContextRetainCount (CGLContextObj ctx);
	CGLPixelFormatObj CGLGetPixelFormat (CGLContextObj ctx);
	int CGLCreatePBuffer (int width, int height, uint target, uint internalFormat, int max_level, CGLPBufferObj* pbuffer);
	int CGLDestroyPBuffer (CGLPBufferObj pbuffer);
	int CGLDescribePBuffer (CGLPBufferObj obj, GLsizei* width, GLsizei* height, GLenum* target, GLenum* internalFormat, GLint* mipmap);
	int CGLTexImagePBuffer (CGLContextObj ctx, CGLPBufferObj pbuffer, uint source);
	CGLPBufferObj CGLRetainPBuffer (CGLPBufferObj pbuffer);
	void CGLReleasePBuffer (CGLPBufferObj pbuffer);
	uint CGLGetPBufferRetainCount (CGLPBufferObj pbuffer);
	int CGLSetOffScreen (CGLContextObj ctx, int width, int height, int rowbytes, void* baseaddr);
	int CGLGetOffScreen (CGLContextObj ctx, GLsizei* width, GLsizei* height, GLint* rowbytes, void** baseaddr);
	int CGLSetFullScreen (CGLContextObj ctx);
	int CGLSetPBuffer (CGLContextObj ctx, CGLPBufferObj pbuffer, uint face, int level, int screen);
	int CGLGetPBuffer (CGLContextObj ctx, CGLPBufferObj* pbuffer, GLenum* face, GLint* level, GLint* screen);
	int CGLClearDrawable (CGLContextObj ctx);
	int CGLFlushDrawable (CGLContextObj ctx);
	int CGLEnable (CGLContextObj ctx, int pname);
	int CGLDisable (CGLContextObj ctx, int pname);
	int CGLIsEnabled (CGLContextObj ctx, int pname, GLint* enable);
	int CGLSetParameter (CGLContextObj ctx, int pname, GLint* params);
	int CGLGetParameter (CGLContextObj ctx, int pname, GLint* params);
	int CGLSetVirtualScreen (CGLContextObj ctx, int screen);
	int CGLGetVirtualScreen (CGLContextObj ctx, GLint* screen);
	int CGLSetOption (int pname, int param);
	int CGLGetOption (int pname, GLint* param);
	int CGLLockContext (CGLContextObj ctx);
	int CGLUnlockContext (CGLContextObj ctx);
	void CGLGetVersion (GLint* majorvers, GLint* minorvers);
	char* CGLErrorString (int error);
}